<template>
  <div>
    <!--查询区域-->
    <div class="jeecg-basic-table-form-container">
      <a-form @keyup.enter.native="searchQuery" :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="6">
            <a-form-item label="应急事件名称">
              <a-input placeholder="请输入应急事件名称" v-model:value="queryParam.name"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6">
            <a-form-item label="事件类型">
              <j-dict-select-tag placeholder="请选择事件类型" v-model:value="queryParam.tp" dictCode="event_tp"/>
           
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">
            <a-col :lg="6">
              <a-form-item label="事件等级">
                 <j-dict-select-tag placeholder="请选择事件等级" v-model:value="queryParam.level" dictCode="level"/>
           
              </a-form-item>
            </a-col>
            <a-col :lg="6">
              <a-form-item label="牵头处置部门">
                <a-input placeholder="请输入牵头处置部门" v-model:value="queryParam.handleDepart"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="6">
              <a-form-item label="事件发生时间">
               <a-range-picker v-model:value="rangeIssuedTime" placeholder="请选择事件发生时间"  />
              </a-form-item>
            </a-col>
            
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left; overflow: hidden" class="table-page-search-submitButtons">
              <a-col :lg="6">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" style="margin-left: 8px">重置</a-button>
                <a @click="toggleSearchStatus = !toggleSearchStatus" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <Icon :icon="toggleSearchStatus ? 'ant-design:up-outlined' : 'ant-design:down-outlined'" />
                </a>
              </a-col>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined"></Icon>
                删除
              </a-menu-item>
            </a-menu>
          </template>
          <a-button>批量操作
            <Icon icon="mdi:chevron-down"></Icon>
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <BcsRiskEventModal ref="registerModal" @success="handleSuccess"  @addHandle="handleDetailEventMethodOrg"></BcsRiskEventModal>
    <BcsRiskEventMethodOrg ref="registerModal_org" ></BcsRiskEventMethodOrg>
     <!-- 事件处置区域 -->
    <BcsRiskEventCheck ref="registerModal_Check"  @success="handleSuccess"></BcsRiskEventCheck>
  </div>
</template>

<script lang="ts" name="bcs.handle-bcsRiskEvent" setup>
  import { ref, reactive,defineComponent } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns } from './BcsRiskEvent.data';
  import { list, deleteOne, batchDelete,updateEventSta } from './BcsRiskEvent.api';
  import BcsRiskEventModal from './components/BcsRiskEventModal.vue';
  import BcsRiskEventMethodOrg from './components/BcsRiskEventMethodOrg.vue';
  import BcsRiskEventCheck from './components/BcsRiskEventCheck.vue';
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import type { Dayjs } from 'dayjs';

  const queryParam = ref<any>({});
  const toggleSearchStatus = ref<boolean>(false);
  const registerModal = ref();
  const registerModal_org = ref();
  const registerModal_Check = ref();

  type RangeValue = [Dayjs, Dayjs];
  const rangeIssuedTime = ref<RangeValue>();
  

  
  //注册table数据
  const { tableContext } = useListPage({
    tableProps: {
      title: '应急处置管理',
      api: list,
      columns,
      canResize:false,
      useSearchForm: false,
      actionColumn: {
        width: 200,
        fixed: 'right',
      },
      beforeFetch: (params) => {
        return Object.assign(params, queryParam.value);
      },
    },
  });
  
  const [registerTable, { reload }, { rowSelection, selectedRowKeys }] = tableContext;
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 8 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });

  /**
   * 新增事件
   */
  function handleAdd() {
    registerModal.value.disableSubmit = false;
    registerModal.value.add();
  }
  
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    registerModal.value.disableSubmit = false;
    registerModal.value.edit(record);
  }
   
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    registerModal.value.disableSubmit = true;
    registerModal.value.edit(record);
  }
   
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
   
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
   
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
   
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '填报处置方案',
        onClick: handleDetailEventMethodOrg.bind(null, record),
         ifShow: ()=> { 
            if(record['eventSta']=='0')
            return  true
            else return false
        }
      },
       {
           label: '处置',
           onClick: handleDetailEventCheck.bind(null, record),
           ifShow: ()=> { 
            if(record['eventSta']=='0'||record['eventSta']=='1')
            return  true
            else return false
            }
         },
    ];
  }
   
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
        ifShow: ()=> { 
            if(record['eventSta']=='0')
            return  true
            else return false
        }
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      }, 
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        },
        ifShow: ()=> { 
            if(record['eventSta']=='0')
            return  true
            else return false
        }
      }
    ]
  }

  /**
   * 查询
   */
  function searchQuery() {
    queryParam.value.rangeIssuedTime = rangeIssuedTime.value;
    reload();
  }
  
  /**
   * 重置
   */
  function searchReset() {
    queryParam.value = {};
    
    rangeIssuedTime.value =null;
    selectedRowKeys.value = [];
    reload();
  }

  /**
   * 事件方案填报
   */
  function handleDetailEventMethodOrg(record: Recordable) {
    registerModal_org.value.disableSubmit = true;
    registerModal_org.value.edit(record);
  }

    /**
   * 事件处置
   */
  function handleDetailEventCheck(record: Recordable) {
    if(record.eventSta=='0'){
      updateEventSta({ id: record.id }, handleSuccess);
      (selectedRowKeys.value = []) && reload();
    }
    registerModal_Check.value.disableSubmit = false;
    registerModal_Check.value.edit(record);
  }
  

</script>

<style lang="less" scoped>
  .jeecg-basic-table-form-container {
    .table-page-search-submitButtons {
      display: block;
      margin-bottom: 24px;
      white-space: nowrap;
    }
  }
</style>